"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.retryCollectionSubscription = void 0;
const asynciterable_1 = require("ix/asynciterable");
const operators_1 = require("ix/asynciterable/operators");
const retryCollectionSubscription_1 = require("../retryCollectionSubscription");
class RetryCollectionSubscriptionAsyncIterable extends asynciterable_1.AsyncIterableX {
    constructor(_source, _options) {
        super();
        this._source = _source;
        this._options = _options;
    }
    [Symbol.asyncIterator](signal) {
        return retryCollectionSubscription_1.retryCollectionSubscription(signal => operators_1.wrapWithAbort(this._source, signal), {
            ...this._options,
            signal,
        })[Symbol.asyncIterator]();
    }
}
function retryCollectionSubscription(options) {
    return function retryCollectionSubscriptionOperatorFunction(source) {
        return new RetryCollectionSubscriptionAsyncIterable(source, options);
    };
}
exports.retryCollectionSubscription = retryCollectionSubscription;
//# sourceMappingURL=retryCollectionSubscription.js.map